/*
 * Scone - The Web Enhancement Framework
 * Copyright (C) 2009 Harald Weinreich, Volkert Buchmann, Frank Wollenweber, Torsten Haß
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 package scone.netobjects;




/**
 * Access and cache Keywords and provides means to update the database
 *
 * @author Harald Weinreich
 * @author Volkert Buchmann
 */

public class KeywordCache implements TableRecordCacheInterface {

    // key1=keywordId  key2=keyword
    protected static CacheTable cache;

    public static Object lock = new Object();
	
    public static void init(int timeTillCleanUp, int gcType) {
        cache = new CacheTable("Keywords", 2, timeTillCleanUp, gcType);
        lock = new Object();
    }

    public static Keyword getById(String id) {
        Keyword keyword = null;

        synchronized (lock) {
            keyword = (Keyword) cache.get(0, id);
            if (keyword == null) {
                keyword = new Keyword(Integer.parseInt(id));
                cache.put(keyword);
            }
        }
        return keyword;
    }
	
    public static Keyword get(String word) {
        Keyword keyword = null;

        synchronized (lock) {
            keyword = (Keyword) cache.get(1, word);
            if (keyword == null) {
                keyword = new Keyword(word);
                cache.put(keyword);
            }
        }
        return keyword;
    }
	
    public static void clean() {
        cache.clean();
    }	
}
